wxDataOutputStream Class Reference | wxWidgets

| Version: 3.2.11

Loading...
Searching...
No Matches
Public Member Functions | List of all members
wxDataOutputStream Class Reference
Class List by Category » Streams

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.2/wxWidgets3.2-3.2.11-1.x86_64/src/wxWidgets-3.2.11/interface/wx/datstrm.h>`

## Detailed Description

This class provides functions that write binary data types in a portable way.

Data can be written in either big-endian or little-endian format, little-endian being the default on all architectures but BigEndianOrdered() can be used to change this. The default format for the floating point types is 80 bit "extended precision" unless `wxUSE_APPLE_IEEE` was turned off during the library compilation, in which case extended precision is not available at all. You can call UseBasicPrecisions() to change this and use the standard IEEE 754 32 bit single precision format for floats and standard 64 bit double precision format for doubles. This is recommended for the new code for better interoperability with other software that typically uses standard IEEE 754 formats for its data, the use of extended precision by default is solely due to backwards compatibility.

If you want to write data to text files (or streams) use wxTextOutputStream instead.

The "<<" operator is overloaded and you can use this class like a standard C++ iostream. See wxDataInputStream for its usage and caveats.

##

Library: wxBase
Category: Streams

See also
  wxDataInputStream

## Public Member Functions
| wxDataOutputStream (wxOutputStream &stream, const wxMBConv &conv=wxConvUTF8)
| Constructs a datastream object from an output stream.
| ~wxDataOutputStream ()
| Destroys the wxDataOutputStream object.
void | BigEndianOrdered (bool be_order)
| If be_order is true, all data will be written in big-endian order, e.g.
wxMBConv * | GetConv () const
| Returns the current text conversion class used for writing strings.
void | SetConv (const wxMBConv &conv)
| Sets the text conversion class used for writing strings.
void | UseBasicPrecisions ()
| Disables the use of extended precision format for floating point numbers.
void | UseExtendedPrecision ()
| Explicitly request the use of extended precision for floating point numbers.
void | Write8 (wxUint8 i8)
| Writes the single byte i8 to the stream.
void | Write8 (const wxUint8 *buffer, size_t size)
| Writes an array of bytes to the stream.
void | Write16 (wxUint16 i16)
| Writes the 16 bit unsigned integer i16 to the stream.
void | Write16 (const wxUint16 *buffer, size_t size)
| Writes an array of 16 bit unsigned integer to the stream.
void | Write32 (wxUint32 i32)
| Writes the 32 bit unsigned integer i32 to the stream.
void | Write32 (const wxUint32 *buffer, size_t size)
| Writes an array of 32 bit unsigned integer to the stream.
void | Write64 (wxUint64 i64)
| Writes the 64 bit unsigned integer i64 to the stream.
void | Write64 (const wxUint64 *buffer, size_t size)
| Writes an array of 64 bit unsigned integer to the stream.
void | WriteFloat (float f)
| Writes the float f to the stream.
void | WriteFloat (const float *buffer, size_t size)
| Writes an array of float to the stream.
void | WriteDouble (double d)
| Writes the double d to the stream.
void | WriteDouble (const double *buffer, size_t size)
| Writes an array of double to the stream.
void | WriteString (const wxString &string)
| Writes string to the stream.

## Constructor & Destructor Documentation

## ◆ wxDataOutputStream()

wxDataOutputStream::wxDataOutputStream | ( | wxOutputStream & | stream,
|  | const wxMBConv & | conv = wxConvUTF8 )

Constructs a datastream object from an output stream.

Only write methods will be available.

Note that the conv parameter is only available in Unicode builds of wxWidgets.

Parameters

  stream | The output stream.
  conv | Charset conversion object used to encoding Unicode strings before writing them to the stream in Unicode mode (see WriteString() for a detailed description). Note that you must not destroy conv before you destroy this wxDataOutputStream instance! It is recommended to use the default value (UTF-8).

## ◆ ~wxDataOutputStream()

wxDataOutputStream::~wxDataOutputStream | ( |  | ) |

Destroys the wxDataOutputStream object.

## Member Function Documentation

## ◆ BigEndianOrdered()

void wxDataOutputStream::BigEndianOrdered | ( | bool | be_order | ) |

If be_order is true, all data will be written in big-endian order, e.g.

for reading on a Sparc or from Java-Streams (which always use big-endian order), otherwise data will be written in little-endian order.

## ◆ GetConv()

wxMBConv * wxDataOutputStream::GetConv | ( |  | ) | const

Returns the current text conversion class used for writing strings.

## ◆ SetConv()

void wxDataOutputStream::SetConv | ( | const wxMBConv & | conv | ) |

Sets the text conversion class used for writing strings.

## ◆ UseBasicPrecisions()

void wxDataOutputStream::UseBasicPrecisions | ( |  | ) |

Disables the use of extended precision format for floating point numbers.

This method disables the use of 80 bit extended precision format for the `float` and `double` values written to the stream, which is used by default (unless `wxUSE_APPLE_IEEE` was set to `0` when building the library, in which case the extended format support is not available at all and this function does nothing).

After calling it, `float` values will be written out in one of IEEE 754 "basic formats", i.e. 32 bit single precision format for floats and 64 bit double precision format for doubles.

Since
  2.9.5

## ◆ UseExtendedPrecision()

void wxDataOutputStream::UseExtendedPrecision | ( |  | ) |

Explicitly request the use of extended precision for floating point numbers.

This function allows the application code to explicitly request the use of 80 bit extended precision format for the floating point numbers. This is the case by default but using this function explicitly ensures that the compilation of code relying on producing the output stream using extended precision would fail when using a version of wxWidgets compiled with `wxUSE_APPLE_IEEE==0` and so not supporting this format at all.

Since
  2.9.5

## ◆ Write16() [1/2]

void wxDataOutputStream::Write16 | ( | const wxUint16 * | buffer,
|  | size_t | size )

Writes an array of 16 bit unsigned integer to the stream.

The number of 16 bit unsigned integer to write is specified with the size variable.

## ◆ Write16() [2/2]

void wxDataOutputStream::Write16 | ( | wxUint16 | i16 | ) |

Writes the 16 bit unsigned integer i16 to the stream.

## ◆ Write32() [1/2]

void wxDataOutputStream::Write32 | ( | const wxUint32 * | buffer,
|  | size_t | size )

Writes an array of 32 bit unsigned integer to the stream.

The number of 32 bit unsigned integer to write is specified with the size variable.

## ◆ Write32() [2/2]

void wxDataOutputStream::Write32 | ( | wxUint32 | i32 | ) |

Writes the 32 bit unsigned integer i32 to the stream.

## ◆ Write64() [1/2]

void wxDataOutputStream::Write64 | ( | const wxUint64 * | buffer,
|  | size_t | size )

Writes an array of 64 bit unsigned integer to the stream.

The number of 64 bit unsigned integer to write is specified with the size variable.

## ◆ Write64() [2/2]

void wxDataOutputStream::Write64 | ( | wxUint64 | i64 | ) |

Writes the 64 bit unsigned integer i64 to the stream.

## ◆ Write8() [1/2]

void wxDataOutputStream::Write8 | ( | const wxUint8 * | buffer,
|  | size_t | size )

Writes an array of bytes to the stream.

The number of bytes to write is specified with the size variable.

## ◆ Write8() [2/2]

void wxDataOutputStream::Write8 | ( | wxUint8 | i8 | ) |

Writes the single byte i8 to the stream.

## ◆ WriteDouble() [1/2]

void wxDataOutputStream::WriteDouble | ( | const double * | buffer,
|  | size_t | size )

Writes an array of double to the stream.

The number of doubles to write is specified by the size variable.

## ◆ WriteDouble() [2/2]

void wxDataOutputStream::WriteDouble | ( | double | d | ) |

Writes the double d to the stream.

The output format is either 80 bit extended precision or, if UseBasicPrecisions() had been called, standard IEEE 754 64 bit double precision.

## ◆ WriteFloat() [1/2]

void wxDataOutputStream::WriteFloat | ( | const float * | buffer,
|  | size_t | size )

Writes an array of float to the stream.

The number of floats to write is specified by the size variable.

Since
  2.9.5

## ◆ WriteFloat() [2/2]

void wxDataOutputStream::WriteFloat | ( | float | f | ) |

Writes the float f to the stream.

If UseBasicPrecisions() had been called, the value is written out using the standard IEEE 754 32 bit single precision format. Otherwise, this method uses the same format as WriteDouble(), i.e. 80 bit extended precision representation.

Since
  2.9.5

## ◆ WriteString()

void wxDataOutputStream::WriteString | ( | const wxString & | string | ) |

Writes string to the stream.

Actually, this method writes the size of the string before writing string itself.

In ANSI build of wxWidgets, the string is written to the stream in exactly same way it is represented in memory. In Unicode build, however, the string is first converted to multibyte representation with conv object passed to stream's constructor (consequently, ANSI applications can read data written by Unicode application, as long as they agree on encoding) and this representation is written to the stream. UTF-8 is used by default.